///////////////////////////////////////////////
//  input.c  ^C}[Og`b^  //
//  2008/02/16                               //
///////////////////////////////////////////////

#include "global.h"

#define IN_COUNT 3		//̓JEgFUOS
#define L_COUNT 150		//Rb

///// ϐ`
volatile uchar constH;
volatile uchar constL;
volatile uchar cnt_DOWN;
volatile uchar cnt_UP;
volatile uchar cnt_ENT;
volatile uchar cnt_MODE;

INSWBITS INSWbits;
INSTBITS INSTbits;

void inp_init(void)
{
	ADCON1 = 0xe;			//AN0 = ANALOG
	TRISA = 0x3f;			//RA6,RA7 OUT
	LATAbits.LATA7 = 1;	//OFF
	LATAbits.LATA6 = 1;	//
	
#if (CONFIG_MHZ == 4)
	constH = 0xec;
	constL = 0x78;
#elif (CONFIG_MHZ == 8)
	constH = 0xd8;
	constL = 0xf0;
	constL = 0x2c;
#elif (CONFIG_MHZ == 16)
	constH = 0xb1;
#elif (CONFIG_MHZ == 10)
	constH = 0xcf;
	constL = 0xe0;
#elif (CONFIG_MHZ == 20)
	constH = 0x9e;
	constL = 0x58;
#elif (CONFIG_MHZ == 32)
	constH = 0x63;
	constL = 0xc0;
#elif (CONFIG_MHZ == 40)
	constH = 0x3c;
	constL = 0xb0;
#else
	constH = 0xd8;
	constL = 0xf0;
#endif

	T0CON = 0x81;						//gpA16bitA1/4
	TMR0H = constH;					//20mS
	TMR0L = constL;
	INTCON2bits.TMR0IP = 1;			//ʃxɂĂ
	INTCONbits.TMR0IE = 1;				//^C}[O荞݋
	cnt_DOWN = cnt_UP = cnt_ENT = cnt_MODE = 0;
	timer_start(TIMER_IN_POLL, 5);		//̓|[OԊu
}

void input(void)
{
	if (!timer_check_start(TIMER_IN_POLL)) return;
	INTCONbits.TMR0IE = 0;				//^C}[0荞݋֎~
	if(cnt_DOWN > (IN_COUNT - 1)){
		if(!DOWN) DOWN_P = 1;
		DOWN = 1;
		DOWN_N = 0;
	}
	if(cnt_DOWN > L_COUNT) DOWN_L = 1;
	if(cnt_DOWN == 0){
		if(DOWN) DOWN_N = 1;
		DOWN = 0;
		DOWN_P = 0;
		DOWN_L = 0;
	}
	if(cnt_UP > (IN_COUNT - 1)){
		if(!UP) UP_P = 1;
		UP = 1;
		UP_N = 0;
	}
	if(cnt_UP > L_COUNT) UP_L = 1;
	if(cnt_UP == 0){
		if(UP) UP_N = 1;
		UP = 0;
		UP_P = 0;
		UP_L = 0;
	}
	if(cnt_ENT > (IN_COUNT - 1)){
		if(!ENT) ENT_P = 1;
		ENT = 1;
		ENT_N = 0;
	}
	if(cnt_ENT > L_COUNT) ENT_L = 1;
	if(cnt_ENT == 0){
		if(ENT) ENT_N = 1;
		ENT = 0;
		ENT_P = 0;
		ENT_L = 0;
	}
	if(cnt_MODE > (IN_COUNT -1)){
		if(!MODE) MODE_P = 1;
		MODE = 1;
		MODE_N = 0;
	}
	if(cnt_MODE > L_COUNT) MODE_L = 1;
	if(cnt_MODE == 0){
		if(MODE) MODE_N = 1;
		MODE = 0;
		MODE_P = 0;
		MODE_L = 0;
	}
	INTCONbits.TMR0IE = 1;			//^C}[0荞݉
}
