//////////////////
//  num_set.c   //
//  2008/02/19  //
//////////////////

#include "global.h"

#define ST_SET_IDOL	0
#define ST_SET_READY	1
#define ST_SET_UPDOWN	2
#define ST_SET_WRITE	3
#define ST_SET_OFF	4

#define min_s		10
#define max_s		40
#define set_init	25

#define min_d		1
#define max_d		50
#define diff_init	10

#define e2addr	0

char set_point;		//ݒl
char set_diff;		//qXeVX
char temp_off;		//x\Ȃ
static char state;
static char min;
static char max;

void (*lcd_func)(char);	//֐ւ̃|C^



rom const char *msg1 = {"ò ƭخ"};
rom const char *msg2 = {"˽ؼ ƭخ"};

void lcd_num2s(char n)
{
	char n1,n2,nflg;
	if(n < 0) {
		nflg = 1;
		n = -n;
	}
	else nflg = 0;
	
	n1 = n/10;
	n2 = n%10;
	if(nflg) lcd_data('-');
	else lcd_data(' ');
	if(n1) lcd_data(n1 + 0x30);
	else lcd_data(' ');
	lcd_data(n2 + 0x30);
	lcd_data('.');
	lcd_data('0');
	lcd_data('');
	lcd_data('C');
}

void lcd_num2d(char n){
	char n1,n2;
	if(n < 0)return;
	
	n1 = n/10;
	n2 = n%10;
	lcd_data(' ');
	lcd_data(n1 + 0x30);
	lcd_data('.');
	lcd_data(n2 + 0x30);
	lcd_data('');
	lcd_data('C');
}

void num_init(void)
{
	set_point = read_e2rom(e2addr);
	if(set_point < min_s || set_point > max_s){
		set_point = set_init;
		write_e2rom(e2addr, set_init);
		delay_ms(7);
		lock_e2rom();
	}
	set_diff = read_e2rom(e2addr + 1);
	if(set_diff < min_d || set_diff > max_d){
		set_diff = diff_init;
		write_e2rom(e2addr + 1, diff_init);
		delay_ms(7);
		lock_e2rom();
	}
	state = ST_SET_IDOL;
}

void num_set(void)
{
	static char buff;
	
	switch(state){
		case ST_SET_IDOL:
			temp_off = 0;
			if(MODE_L){
				lcd_clear();
				lcd_cmd(0x80);
				lcd_str_rom(msg1);
				buff = set_point;
				min = min_s;
				max = max_s;
				lcd_func = lcd_num2s;
				lcd_cmd(0xc0);
				lcd_func(buff);
				state = ST_SET_READY;
				temp_off = 1;
				return;
			}
			if(ENT_L){
				lcd_clear();
				lcd_cmd(0x80);
				lcd_str_rom(msg2);
				buff = set_diff;
				min = min_d;
				max = max_d;
				lcd_func = lcd_num2d;
				lcd_cmd(0xc0);
				lcd_func(buff);
				state = ST_SET_READY;
				temp_off = 1;
				return;
			}
			break;
		case ST_SET_READY:
			if(!MODE && !ENT){
				state = ST_SET_UPDOWN;
				timer_start(TIMER_SCAN, 10);
				return;
			}
			break;
		case ST_SET_UPDOWN:
			if(!timer_check(TIMER_SCAN))return;
			if(DOWN && (!DOWN_L)){
				if(buff > min) buff--;
				lcd_cmd(0xc0);
				lcd_func(buff);
				timer_start(TIMER_SCAN, 800);
				timer_cancel(TIMER_SET_CANCEL);
				return;
			}
			if(DOWN_L){
				if(buff > min) buff--;
				lcd_cmd(0xc0);
				lcd_func(buff);
				timer_start(TIMER_SCAN, 80);
				return;
			}		
			if(UP && (!UP_L)){
				if(buff < max) buff++;
				lcd_cmd(0xc0);
				lcd_func(buff);
				timer_start(TIMER_SCAN, 800);
				timer_cancel(TIMER_SET_CANCEL);
				return;
			}
			if(UP_L){
				if(buff < max) buff++;
				lcd_cmd(0xc0);
				lcd_func(buff);
				timer_start(TIMER_SCAN, 80);
				return;
			}
			if(ENT_L){
				if(lcd_func == lcd_num2s){
					set_point = buff;
					write_e2rom(e2addr, set_point);
				}
				if(lcd_func == lcd_num2d){
					set_diff = buff;
					write_e2rom(e2addr + 1, set_diff);
				}
				timer_start(TIMER_E2WRITE, 7);
				lcd_clear();
				timer_cancel(TIMER_SCAN);
				timer_cancel(TIMER_SET_CANCEL);
				state = ST_SET_WRITE;
				return;
			}
			if(MODE_P){
				MODE_P = 0;
				lcd_clear();
				timer_cancel(TIMER_SCAN);
				timer_cancel(TIMER_SET_CANCEL);
				state = ST_SET_IDOL;
				return;
			}
			if(!UP && !DOWN){
				timer_start(TIMER_SET_CANCEL, 60000);
			}
			if(timer_check(TIMER_SET_CANCEL)){
				lcd_clear();
				timer_cancel(TIMER_SCAN);
				state = ST_SET_IDOL;
				return;
			}
			timer_start(TIMER_SCAN, 10);
			break;
		case ST_SET_WRITE:
			if(!timer_check(TIMER_E2WRITE))return;
			lock_e2rom();
			state = ST_SET_OFF;
			break;
		case ST_SET_OFF:
			if(ENT)return;
			state = ST_SET_IDOL;
			break;
			
	}
}
